#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 30
#property indicator_level2 70
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
//--------------------------------------------------------------------------------------------------------------------
extern int RSIPeriod=14;
//--------------------------------------------------------------------------------------------------------------------
double RSIBuffer[];
double RSIColorBuffer[];
double PosBuffer[];
double NegBuffer[];
//
int init()
  {
   string short_name;
   IndicatorBuffers(4);
//--------------------------------------------------------------------------------------------------------------------
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, RSIColorBuffer);

   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, RSIBuffer);
//--------------------------------------------------------------------------------------------------------------------
   SetIndexBuffer(2,PosBuffer);
   SetIndexBuffer(3,NegBuffer);
//--------------------------------------------------------------------------------------------------------------------
   short_name="RSI Color("+RSIPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"");
//--------------------------------------------------------------------------------------------------------------------
   SetIndexDrawBegin(0,RSIPeriod);
   SetIndexDrawBegin(1,RSIPeriod);
//--------------------------------------------------------------------------------------------------------------------
   return(0);
  }
//
int start()
  {
   if(Bars<=RSIPeriod) return(0);
//--------------------------------------------------------------------------------------------------------------------
   int    k,i,counted_bars=IndicatorCounted();
   double rel,negative,positive,sumn,sump;
//--------------------------------------------------------------------------------------------------------------------
   if(counted_bars<1)
      {
      for(i=1;i<=RSIPeriod;i++) 
         {
         RSIBuffer[Bars-i]=0.0;
         RSIColorBuffer[Bars-i]=0.0;
         }
      }
//--------------------------------------------------------------------------------------------------------------------
   i=Bars-RSIPeriod-1;
   if(counted_bars>=RSIPeriod) i=Bars-counted_bars-1;
//====================================================================================================================
   while(i>=0)
      {
      sumn=0;
      sump=0;
      if(i==Bars-RSIPeriod-1)
         {
         k=Bars-2;
         rel=Close[k]-Close[k+1];
         if(rel>0) sump+=rel;
         else      sumn-=rel;
         k--;
         positive=sump/RSIPeriod;
         negative=sumn/RSIPeriod;
         }
      else
         {
         rel=Close[i]-Close[i+1];
         if(rel>0) sump=rel;
         else      sumn=-rel;
         positive=(PosBuffer[i+1]*(RSIPeriod-1)+sump)/RSIPeriod;
         negative=(NegBuffer[i+1]*(RSIPeriod-1)+sumn)/RSIPeriod;
         }
//--------------------------------------------------------------------------------------------------------------------
      PosBuffer[i]=positive;
      NegBuffer[i]=negative;
      if(negative==0.0) RSIBuffer[i]=0.0;
      else
         {
         negative = 100.0-100.0/(1+positive/negative);
         RSIColorBuffer[i] = negative;
         if ((negative > indicator_level2)||(negative < indicator_level1)) negative = EMPTY_VALUE;
         RSIBuffer[i] = negative;
         }
      i--;
//--------------------------------------------------------------------------------------------------------------------
     }
//====================================================================================================================
   return(0);
  }
//

